Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/thd_ice.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/thd_ice.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/thd_ice.F90	(revision 3938)
@@ -22,5 +22,4 @@
    REAL(wp), PUBLIC ::   hicmin  = 0.2       !: (REMOVE)
    REAL(wp), PUBLIC ::   hiclim  = 0.05      !: minimum ice thickness
-   REAL(wp), PUBLIC ::   amax    = 0.999     !: maximum lead fraction
    REAL(wp), PUBLIC ::   sbeta   = 1.0       !: numerical scheme for diffusion in ice  (REMOVE)
    REAL(wp), PUBLIC ::   parlat  = 0.0       !: (REMOVE)
@@ -83,5 +82,5 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   i0            !: fraction of radiation transmitted to the ice
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   old_ht_i_b    !: Ice thickness at the beginnning of the time step [m]
-    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::  old_ht_s_b    !: Snow thickness at the beginning of the time step [m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   old_ht_s_b    !: Snow thickness at the beginning of the time step [m]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   fsbri_1d      !: Salt flux due to brine drainage
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   fhbri_1d      !: Heat flux due to brine drainage
@@ -108,4 +107,7 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   o_i_b       !: Ice age                        [days]
 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   iatte_1d   !: clem attenuation coef of the input solar flux (unitless)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   oatte_1d   !: clem attenuation coef of the input solar flux (unitless)
+
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   t_s_b   !: corresponding to the 2D var  t_s
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   t_i_b   !: corresponding to the 2D var  t_i
@@ -157,5 +159,6 @@
          &      fltbif_1d(jpij) , fscbq_1d (jpij) , qsr_ice_1d (jpij) ,     &
          &      fr1_i0_1d(jpij) , fr2_i0_1d(jpij) , qnsr_ice_1d(jpij) ,     &
-         &      qfvbq_1d (jpij) , t_bo_b   (jpij)                     , STAT=ierr(1) )
+         &      qfvbq_1d (jpij) , t_bo_b   (jpij) , iatte_1d   (jpij) ,     &
+         &      oatte_1d (jpij)                                       , STAT=ierr(1) )
       !
       ALLOCATE( sprecip_1d (jpij) , frld_1d    (jpij) , at_i_b     (jpij) ,     &
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 3938)
@@ -8,4 +8,5 @@
    !!            3.3  !  2010-09  (D. Storkey) add ice boundary conditions
    !!            3.4  !  2011     (D. Storkey) rewrite in preparation for OBC-BDY merge
+   !!             -   !  2012-01  (C. Rousset) add ice boundary conditions for lim3
    !!----------------------------------------------------------------------
 #if defined key_bdy 
@@ -44,4 +45,8 @@
       REAL, POINTER, DIMENSION(:)     ::  hicif
       REAL, POINTER, DIMENSION(:)     ::  hsnif
+#elif defined key_lim3
+      REAL, POINTER, DIMENSION(:,:)   ::  a_i   !: now ice leads fraction climatology
+      REAL, POINTER, DIMENSION(:,:)   ::  ht_i  !: Now ice  thickness climatology
+      REAL, POINTER, DIMENSION(:,:)   ::  ht_s  !: now snow thickness
 #endif
    END TYPE OBC_DATA
@@ -73,7 +78,7 @@
    INTEGER, DIMENSION(jp_bdy) ::   nn_tra_dta      	    !: = 0 use the initial state as bdy dta ; 
                                                             !: = 1 read it in a NetCDF file
-#if defined key_lim2
-   INTEGER, DIMENSION(jp_bdy) ::   nn_ice_lim2              ! Choice of boundary condition for sea ice variables 
-   INTEGER, DIMENSION(jp_bdy) ::   nn_ice_lim2_dta          !: = 0 use the initial state as bdy dta ; 
+#if ( defined key_lim2 || defined key_lim3 )
+   INTEGER, DIMENSION(jp_bdy) ::   nn_ice_lim               ! Choice of boundary condition for sea ice variables 
+   INTEGER, DIMENSION(jp_bdy) ::   nn_ice_lim_dta           !: = 0 use the initial state as bdy dta ; 
                                                             !: = 1 read it in a NetCDF file
 #endif
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 3938)
@@ -11,4 +11,5 @@
    !!            3.3  !  2010-09  (D.Storkey) add ice boundary conditions
    !!            3.4  !  2011     (D. Storkey) rewrite in preparation for OBC-BDY merge
+   !!             -   !  2012-01  (C. Rousset) add ice boundary conditions for lim3
    !!----------------------------------------------------------------------
 #if defined key_bdy
@@ -31,4 +32,8 @@
 #if defined key_lim2
    USE ice_2
+#elif defined key_lim3
+   USE par_ice
+   USE ice
+   USE limcat_1D          ! redistribute ice input into categories
 #endif
 
@@ -48,4 +53,9 @@
 
    TYPE(MAP_POINTER), ALLOCATABLE, DIMENSION(:) :: nbmap_ptr   ! array of pointers to nbmap
+
+#if defined key_lim3
+   LOGICAL :: ll_bdylim3                  ! determine whether ice input is lim2 (F) or lim3 (T) type
+   INTEGER :: jfld_hti, jfld_hts, jfld_ai ! indices of ice thickness, snow thickness and concentration in bf structure
+#endif
 
 #  include "domzgr_substitute.h90"
@@ -76,5 +86,5 @@
                                                         ! etc.
       !!
-      INTEGER     ::  ib_bdy, jfld, jstart, jend, ib, ii, ij, ik, igrd  ! local indices
+      INTEGER     ::  ib_bdy, jfld, jstart, jend, ib, ii, ij, ik, igrd, jl  ! local indices
       INTEGER,          DIMENSION(jpbgrd) ::   ilen1 
       INTEGER, POINTER, DIMENSION(:)      ::   nblen, nblenrim  ! short cuts
@@ -175,6 +185,6 @@
 
 #if defined key_lim2
-            IF( nn_ice_lim2(ib_bdy) .gt. 0 .and. nn_ice_lim2_dta(ib_bdy) .eq. 0 ) THEN 
-               IF( nn_ice_lim2(ib_bdy) .eq. jp_frs ) THEN
+            IF( nn_ice_lim(ib_bdy) .gt. 0 .and. nn_ice_lim_dta(ib_bdy) .eq. 0 ) THEN 
+               IF( nn_ice_lim(ib_bdy) .eq. jp_frs ) THEN
                   ilen1(:) = nblen(:)
                ELSE
@@ -185,8 +195,26 @@
                   ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
                   ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                  dta_bdy(ib_bdy)%frld(ib) = frld(ii,ij) * tmask(ii,ij,1)         
+                  dta_bdy(ib_bdy)%frld (ib) =  frld(ii,ij) * tmask(ii,ij,1)         
                   dta_bdy(ib_bdy)%hicif(ib) = hicif(ii,ij) * tmask(ii,ij,1)         
                   dta_bdy(ib_bdy)%hsnif(ib) = hsnif(ii,ij) * tmask(ii,ij,1)         
                END DO 
+            ENDIF
+#elif defined key_lim3
+            IF( nn_ice_lim(ib_bdy) .gt. 0 .and. nn_ice_lim_dta(ib_bdy) .eq. 0 ) THEN 
+               IF( nn_ice_lim(ib_bdy) .eq. jp_frs ) THEN
+                  ilen1(:) = nblen(:)
+               ELSE
+                  ilen1(:) = nblenrim(:)
+               ENDIF
+               igrd = 1                       ! Everything is at T-points here
+               DO jl = 1, jpl
+                  DO ib = 1, ilen1(igrd)
+                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                     dta_bdy(ib_bdy)%a_i (ib,jl) =  a_i(ii,ij,jl) * tmask(ii,ij,1) 
+                     dta_bdy(ib_bdy)%ht_i(ib,jl) = ht_i(ii,ij,jl) * tmask(ii,ij,1) 
+                     dta_bdy(ib_bdy)%ht_s(ib,jl) = ht_s(ii,ij,jl) * tmask(ii,ij,1) 
+                  END DO
+               END DO
             ENDIF
 #endif
@@ -237,4 +265,14 @@
                   CALL tide_update( kt=kt, idx=idx_bdy(ib_bdy), dta=dta_bdy(ib_bdy), td=tides(ib_bdy), time_offset=time_offset )
                ENDIF
+
+#if defined key_lim3
+               IF( nn_ice_lim(ib_bdy) .gt. 0 .and. nn_ice_lim_dta(ib_bdy) .eq. 1 ) THEN ! bdy ice input
+     	          IF ( .NOT. ll_bdylim3 ) THEN ! case input is lim2 type
+     	             CALL lim_cat_1D ( bf(jfld_hti)%fnow(:,1,1), bf(jfld_hts)%fnow(:,1,1), bf(jfld_ai)%fnow(:,1,1), &
+                                     & dta_bdy(ib_bdy)%ht_i,     dta_bdy(ib_bdy)%ht_s,     dta_bdy(ib_bdy)%a_i     )
+     	          ENDIF
+               ENDIF
+#endif
+
             ENDIF
             jstart = jend+1
@@ -311,13 +349,22 @@
       INTEGER, ALLOCATABLE, DIMENSION(:)     ::   igrid         ! index for grid type (1,2,3 = T,U,V)
       INTEGER, POINTER, DIMENSION(:)         ::   nblen, nblenrim  ! short cuts
+#if defined key_lim3
+      INTEGER, DIMENSION(3) ::   zdimsz   ! number of elements in each of the 4 dimensions (i.e. i,j,t,ice-cat) for an array
+      INTEGER               ::   zndims   ! number of dimensions in an array (i.e. 3 = wo ice cat; 4 = w ice cat)
+      INTEGER               ::   inum,id1 ! local integer
+#endif
       TYPE(FLD_N), ALLOCATABLE, DIMENSION(:) ::   blf_i         !  array of namelist information structures
       TYPE(FLD_N) ::   bn_tem, bn_sal, bn_u3d, bn_v3d   ! 
       TYPE(FLD_N) ::   bn_ssh, bn_u2d, bn_v2d           ! informations about the fields to be read
 #if defined key_lim2
-      TYPE(FLD_N) ::   bn_frld, bn_hicif, bn_hsnif      !
+      TYPE(FLD_N) ::   bn_frld, bn_hicif, bn_hsnif      
+#elif defined key_lim3
+      TYPE(FLD_N) ::   bn_a_i, bn_ht_i, bn_ht_s      
 #endif
       NAMELIST/nambdy_dta/ cn_dir, bn_tem, bn_sal, bn_u3d, bn_v3d, bn_ssh, bn_u2d, bn_v2d 
 #if defined key_lim2
       NAMELIST/nambdy_dta/ bn_frld, bn_hicif, bn_hsnif
+#elif defined key_lim3
+      NAMELIST/nambdy_dta/ bn_a_i, bn_ht_i, bn_ht_s
 #endif
       NAMELIST/nambdy_dta/ ln_full_vel
@@ -326,11 +373,11 @@
       IF( nn_timing == 1 ) CALL timing_start('bdy_dta_init')
 
-      ! Set nn_dta
+      ! Set nn_dta to 0 or 1
       DO ib_bdy = 1, nb_bdy
-         nn_dta(ib_bdy) = MAX(  nn_dyn2d_dta(ib_bdy)       &
-                               ,nn_dyn3d_dta(ib_bdy)       &
-                               ,nn_tra_dta(ib_bdy)         &
-#if defined key_lim2
-                               ,nn_ice_lim2_dta(ib_bdy)    &
+         nn_dta(ib_bdy) = MAX( nn_dyn2d_dta(ib_bdy)       &
+                              ,nn_dyn3d_dta(ib_bdy)       &
+                              ,nn_tra_dta(ib_bdy)         &
+#if ( defined key_lim2 || defined key_lim3 )
+                              ,nn_ice_lim_dta(ib_bdy)    &
 #endif
                               )
@@ -352,6 +399,6 @@
             nb_bdy_fld(ib_bdy) = nb_bdy_fld(ib_bdy) + 2
          ENDIF
-#if defined key_lim2
-         IF( nn_ice_lim2(ib_bdy) .gt. 0 .and. nn_ice_lim2_dta(ib_bdy) .eq. 1  ) THEN
+#if ( defined key_lim2 || defined key_lim3 )
+         IF( nn_ice_lim(ib_bdy) .gt. 0 .and. nn_ice_lim_dta(ib_bdy) .eq. 1  ) THEN
             nb_bdy_fld(ib_bdy) = nb_bdy_fld(ib_bdy) + 3
          ENDIF
@@ -377,5 +424,5 @@
       ALLOCATE( igrid(nb_bdy_fld_sum) ) 
 
-      ! Read namelists
+     ! Read namelists
       ! --------------
       REWIND(numnam)
@@ -387,17 +434,21 @@
             ln_full_vel = .false.
             ! ... default values (NB: frequency positive => hours, negative => months)
-            !                    !  file       ! frequency !  variable   ! time intep !  clim   ! 'yearly' or ! weights  ! rotation  !
-            !                    !  name       ! hours !   name     !  (T/F)  !  (T/F)  !  'monthly'  ! filename ! pairs     !
-            bn_ssh     = FLD_N(  'bdy_ssh'     ,  24   , 'sossheig' , .false. , .false. ,   'yearly'  , ''       , ''        )
-            bn_u2d     = FLD_N(  'bdy_vel2d_u' ,  24   , 'vobtcrtx' , .false. , .false. ,   'yearly'  , ''       , ''        )
-            bn_v2d     = FLD_N(  'bdy_vel2d_v' ,  24   , 'vobtcrty' , .false. , .false. ,   'yearly'  , ''       , ''        )
-            bn_u3d     = FLD_N(  'bdy_vel3d_u' ,  24   , 'vozocrtx' , .false. , .false. ,   'yearly'  , ''       , ''        )
-            bn_v3d     = FLD_N(  'bdy_vel3d_v' ,  24   , 'vomecrty' , .false. , .false. ,   'yearly'  , ''       , ''        )
-            bn_tem     = FLD_N(  'bdy_tem'     ,  24   , 'votemper' , .false. , .false. ,   'yearly'  , ''       , ''        )
-            bn_sal     = FLD_N(  'bdy_sal'     ,  24   , 'vosaline' , .false. , .false. ,   'yearly'  , ''       , ''        )
+            !                 !  file       ! frequency !  variable  ! time intep !  clim   ! 'yearly' or ! weights  ! rotation  !
+            !                 !  name       ! hours     !   name     !  (T/F)     !  (T/F)  !  'monthly'  ! filename ! pairs     !
+            bn_ssh   = FLD_N(  'bdy_ssh'     ,  24      , 'sossheig' , .false.    , .false. ,   'yearly'  , ''       , ''        )
+            bn_u2d   = FLD_N(  'bdy_vel2d_u' ,  24      , 'vobtcrtx' , .false.    , .false. ,   'yearly'  , ''       , ''        )
+            bn_v2d   = FLD_N(  'bdy_vel2d_v' ,  24      , 'vobtcrty' , .false.    , .false. ,   'yearly'  , ''       , ''        )
+            bn_u3d   = FLD_N(  'bdy_vel3d_u' ,  24      , 'vozocrtx' , .false.    , .false. ,   'yearly'  , ''       , ''        )
+            bn_v3d   = FLD_N(  'bdy_vel3d_v' ,  24      , 'vomecrty' , .false.    , .false. ,   'yearly'  , ''       , ''        )
+            bn_tem   = FLD_N(  'bdy_tem'     ,  24      , 'votemper' , .false.    , .false. ,   'yearly'  , ''       , ''        )
+            bn_sal   = FLD_N(  'bdy_sal'     ,  24      , 'vosaline' , .false.    , .false. ,   'yearly'  , ''       , ''        )
 #if defined key_lim2
-            bn_frld    = FLD_N(  'bdy_frld'    ,  24   , 'ildsconc' , .false. , .false. ,   'yearly'  , ''       , ''        )
-            bn_hicif   = FLD_N(  'bdy_hicif'   ,  24   , 'iicethic' , .false. , .false. ,   'yearly'  , ''       , ''        )
-            bn_hsnif   = FLD_N(  'bdy_hsnif'   ,  24   , 'isnothic' , .false. , .false. ,   'yearly'  , ''       , ''        )
+            bn_frld  = FLD_N(  'bdy_frld'    ,  24      , 'ildsconc' , .false.    , .false. ,   'yearly'  , ''       , ''        )
+            bn_hicif = FLD_N(  'bdy_hicif'   ,  24      , 'iicethic' , .false.    , .false. ,   'yearly'  , ''       , ''        )
+            bn_hsnif = FLD_N(  'bdy_hsnif'   ,  24      , 'isnothic' , .false.    , .false. ,   'yearly'  , ''       , ''        )
+#elif defined key_lim3
+            bn_a_i  = FLD_N(  'bdy_a_i'     ,  24   , 'ileadfra' , .false. , .false. ,   'yearly'  , ''       , ''        )
+            bn_ht_i = FLD_N(  'bdy_ht_i'    ,  24   , 'iicethic' , .false. , .false. ,   'yearly'  , ''       , ''        )
+            bn_ht_s = FLD_N(  'bdy_ht_s'    ,  24   , 'isnowthi' , .false. , .false. ,   'yearly'  , ''       , ''        )
 #endif
 
@@ -515,5 +566,5 @@
 #if defined key_lim2
             ! sea ice
-            IF( nn_ice_lim2(ib_bdy) .gt. 0 .and. nn_ice_lim2_dta(ib_bdy) .eq. 1 ) THEN
+            IF( nn_ice_lim(ib_bdy) .gt. 0 .and. nn_ice_lim_dta(ib_bdy) .eq. 1 ) THEN
 
                jfld = jfld + 1
@@ -521,5 +572,5 @@
                ibdy(jfld) = ib_bdy
                igrid(jfld) = 1
-               IF( nn_ice_lim2(ib_bdy) .eq. jp_frs ) THEN
+               IF( nn_ice_lim(ib_bdy) .eq. jp_frs ) THEN
                   ilen1(jfld) = nblen(igrid(jfld))
                ELSE
@@ -532,5 +583,5 @@
                ibdy(jfld) = ib_bdy
                igrid(jfld) = 1
-               IF( nn_ice_lim2(ib_bdy) .eq. jp_frs ) THEN
+               IF( nn_ice_lim(ib_bdy) .eq. jp_frs ) THEN
                   ilen1(jfld) = nblen(igrid(jfld))
                ELSE
@@ -543,5 +594,5 @@
                ibdy(jfld) = ib_bdy
                igrid(jfld) = 1
-               IF( nn_ice_lim2(ib_bdy) .eq. jp_frs ) THEN
+               IF( nn_ice_lim(ib_bdy) .eq. jp_frs ) THEN
                   ilen1(jfld) = nblen(igrid(jfld))
                ELSE
@@ -549,4 +600,56 @@
                ENDIF
                ilen3(jfld) = 1
+
+            ENDIF
+#elif defined key_lim3
+            ! sea ice
+            IF( nn_ice_lim(ib_bdy) .gt. 0 .and. nn_ice_lim_dta(ib_bdy) .eq. 1 ) THEN
+
+               ! Test for types of ice input (lim2 or lim3) 
+               CALL iom_open ( bn_a_i%clname, inum )
+               id1 = iom_varid ( inum, bn_a_i%clvar, kdimsz=zdimsz, kndims=zndims, ldstop = .FALSE. )
+               CALL iom_close ( inum )
+               !CALL fld_clopn ( bn_a_i, nyear, nmonth, nday, ldstop=.TRUE. )
+               !CALL iom_open ( bn_a_i%clname, inum )
+               !id1 = iom_varid ( bn_a_i%num, bn_a_i%clvar, kdimsz=zdimsz, kndims=zndims, ldstop = .FALSE. )
+      	       IF ( zndims == 4 ) THEN
+                 ll_bdylim3 = .TRUE.
+               ELSE
+                 ll_bdylim3 = .FALSE.        
+               ENDIF
+               ! End test
+
+               jfld = jfld + 1
+               blf_i(jfld) = bn_a_i
+               ibdy(jfld) = ib_bdy
+               igrid(jfld) = 1
+               IF( nn_ice_lim(ib_bdy) .eq. jp_frs ) THEN
+                  ilen1(jfld) = nblen(igrid(jfld))
+               ELSE
+                  ilen1(jfld) = nblenrim(igrid(jfld))
+               ENDIF
+               IF ( ll_bdylim3 ) THEN ; ilen3(jfld)=jpl ; ELSE ; ilen3(jfld)=1 ; ENDIF
+
+               jfld = jfld + 1
+               blf_i(jfld) = bn_ht_i
+               ibdy(jfld) = ib_bdy
+               igrid(jfld) = 1
+               IF( nn_ice_lim(ib_bdy) .eq. jp_frs ) THEN
+                  ilen1(jfld) = nblen(igrid(jfld))
+               ELSE
+                  ilen1(jfld) = nblenrim(igrid(jfld))
+               ENDIF
+               IF ( ll_bdylim3 ) THEN ; ilen3(jfld)=jpl ; ELSE ; ilen3(jfld)=1 ; ENDIF
+
+               jfld = jfld + 1
+               blf_i(jfld) = bn_ht_s
+               ibdy(jfld) = ib_bdy
+               igrid(jfld) = 1
+               IF( nn_ice_lim(ib_bdy) .eq. jp_frs ) THEN
+                  ilen1(jfld) = nblen(igrid(jfld))
+               ELSE
+                  ilen1(jfld) = nblenrim(igrid(jfld))
+               ENDIF
+               IF ( ll_bdylim3 ) THEN ; ilen3(jfld)=jpl ; ELSE ; ilen3(jfld)=1 ; ENDIF
 
             ENDIF
@@ -652,7 +755,7 @@
 
 #if defined key_lim2
-         IF (nn_ice_lim2(ib_bdy) .gt. 0) THEN
-            IF( nn_ice_lim2_dta(ib_bdy) .eq. 0 ) THEN
-               IF( nn_ice_lim2(ib_bdy) .eq. jp_frs ) THEN
+         IF (nn_ice_lim(ib_bdy) .gt. 0) THEN
+            IF( nn_ice_lim_dta(ib_bdy) .eq. 0 ) THEN
+               IF( nn_ice_lim(ib_bdy) .eq. jp_frs ) THEN
                   ilen0(1:3) = nblen(1:3)
                ELSE
@@ -669,4 +772,40 @@
                jfld = jfld + 1
                dta_bdy(ib_bdy)%hsnif => bf(jfld)%fnow(:,1,1)
+            ENDIF
+         ENDIF
+#elif defined key_lim3
+         IF (nn_ice_lim(ib_bdy) .gt. 0) THEN
+            IF( nn_ice_lim(ib_bdy) .eq. jp_frs ) THEN
+               ilen0(1:3) = nblen(1:3)
+            ELSE
+               ilen0(1:3) = nblenrim(1:3)
+            ENDIF
+            IF( nn_ice_lim_dta(ib_bdy) .eq. 0 ) THEN
+               ALLOCATE( dta_bdy(ib_bdy)%a_i (ilen0(1),jpl) )
+               ALLOCATE( dta_bdy(ib_bdy)%ht_i(ilen0(1),jpl) )
+               ALLOCATE( dta_bdy(ib_bdy)%ht_s(ilen0(1),jpl) )
+            ELSE
+               IF ( ll_bdylim3 ) THEN
+                  jfld = jfld + 1
+                  dta_bdy(ib_bdy)%a_i  => bf(jfld)%fnow(:,1,:)
+                  jfld = jfld + 1
+                  dta_bdy(ib_bdy)%ht_i => bf(jfld)%fnow(:,1,:)
+                  jfld = jfld + 1
+                  dta_bdy(ib_bdy)%ht_s => bf(jfld)%fnow(:,1,:)
+               ELSE
+                  jfld    = jfld + 1                  
+                  jfld_ai = jfld
+                  ALLOCATE( dta_bdy(ib_bdy)%a_i (ilen0(1),jpl) )
+                  dta_bdy(ib_bdy)%a_i(:,:) = 0.0
+                  jfld     = jfld + 1                  
+                  jfld_hti = jfld
+                  ALLOCATE( dta_bdy(ib_bdy)%ht_i(ilen0(1),jpl) )
+                  dta_bdy(ib_bdy)%ht_i(:,:) = 0.0
+                  jfld     = jfld + 1                  
+                  jfld_hts = jfld
+                  ALLOCATE( dta_bdy(ib_bdy)%ht_s(ilen0(1),jpl) )
+                  dta_bdy(ib_bdy)%ht_s(:,:) = 0.0
+               ENDIF
+
             ENDIF
          ENDIF
